using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using CyUSB;
using CyUSB.Async;

using System.Threading;

namespace USBTest {

	/*
	 * I apologize.. this code is rather messy, and has no exception handling. However, its
	 * really just used to test the library out, not any kind of production usage. 
	 */

	public partial class Form1 : System.Windows.Forms.Form {


		USBDeviceList usbDevices;
		CyUSBDevice usbDevice;

		CyUSBAsyncWrapper pcToUSB;
		CyUSBAsyncWrapper usbToPc;

		public Form1(){

			InitializeComponent();

			App_PnP_Callback evHandler = new App_PnP_Callback(PnP_Event_Handler);
			usbDevices = new USBDeviceList(CyConst.DEVICES_CYUSB, evHandler);
            usbConfig1.Init(usbDevices);
		}


		public void PnP_Event_Handler(IntPtr pnpEvent, IntPtr hRemovedDevice) 
        {

			if (pnpEvent.Equals(CyConst.DBT_DEVICEREMOVECOMPLETE)) 
            {
                usbDevices.Remove(hRemovedDevice);
                // Other removal event handling  
			}

			if (pnpEvent.Equals(CyConst.DBT_DEVICEARRIVAL)) 
            {
                usbDevices.Add();
                // Other arrival event handling  
			}

			usbConfig1.UsbConfig_ReConfig();
		}



		private void button2_Click(object sender, EventArgs e) {
			groupBox1.Enabled = !groupBox1.Enabled;
			usbConfig1.Enabled = !groupBox1.Enabled;

			if ( groupBox1.Enabled ) 
            {
				button2.Text = "Deselect";
				ConfigureDevice();
			} else
				button2.Text = "Select";

		}

		/// <summary>
		/// Configures the selected device
		/// </summary>
		private void ConfigureDevice() 
        {

			if ( usbConfig1.comboBox1.SelectedIndex == -1 )
				return;

			// unconfigure previous device (abort its receive thread)

			// configure new device

			usbDevice = usbDevices[usbConfig1.comboBox1.SelectedIndex] as CyUSBDevice;

			// transfer data from pc to the usb device
			pcToUSB = new CyUSBAsyncWrapper(usbDevice.BulkOutEndPt);
			usbToPc = new CyUSBAsyncWrapper(usbDevice.BulkInEndPt);

			textBox2.Text = "";
        }


		ASCIIEncoding encoder = new ASCIIEncoding();
		

		private void bSendAsync_Click(object sender, EventArgs e) {
			System.Diagnostics.Debug.WriteLine(DateTime.Now.ToLongTimeString() + " bSendAsync_Click enter");

			byte [] data = encoder.GetBytes(textBox1.Text);
			pcToUSB.BeginTransfer(data, data.Length, new AsyncCallback(EndSend), null);

			System.Diagnostics.Debug.WriteLine(DateTime.Now.ToLongTimeString() + " bSendAsync_Click exit");
		}

		private void bSendBlock_Click(object sender, EventArgs e) {
			System.Diagnostics.Debug.WriteLine(DateTime.Now.ToLongTimeString() + " bSendBlock_Click enter");

			byte[] data = encoder.GetBytes(textBox1.Text);
			pcToUSB.Transfer(data, data.Length);

			System.Diagnostics.Debug.WriteLine(DateTime.Now.ToLongTimeString() + " bSendBlock_Click exit");
		}

		private void bAbortSend_Click(object sender, EventArgs e) {
			System.Diagnostics.Debug.WriteLine(DateTime.Now.ToLongTimeString() + " bAbortSend_Click enter");

			pcToUSB.Abort();

			System.Diagnostics.Debug.WriteLine(DateTime.Now.ToLongTimeString() + " bAbortSend_Click exit");
		}

		private void bRecvAsync_Click(object sender, EventArgs e) {
			System.Diagnostics.Debug.WriteLine(DateTime.Now.ToLongTimeString() + " bRecvAsync_Click enter");

			byte[] data = new byte[64];
			usbToPc.BeginTransfer(data, data.Length, new AsyncCallback(EndRecv), data);

			System.Diagnostics.Debug.WriteLine(DateTime.Now.ToLongTimeString() + " bRecvAsync_Click exit");
		}

		private void bRecvBlock_Click(object sender, EventArgs e) {
			ThreadPool.QueueUserWorkItem(new WaitCallback(bRecvBlock_Thread));
		}

		private void bRecvBlock_Thread(object state) {
			System.Diagnostics.Debug.WriteLine(DateTime.Now.ToLongTimeString() + " bRecvBlock_Thread enter");

			byte[] data = new byte[64];
			int recv = usbToPc.Transfer(data, data.Length);

			AddToTextBox(data, recv);

			System.Diagnostics.Debug.WriteLine(DateTime.Now.ToLongTimeString() + " bRecvBlock_Thread exit");
		}

		private void bAbortRecv_Click(object sender, EventArgs e) {
			System.Diagnostics.Debug.WriteLine(DateTime.Now.ToLongTimeString() + " bAbortRecv_Click enter");

			usbToPc.Abort();

			System.Diagnostics.Debug.WriteLine(DateTime.Now.ToLongTimeString() + " bAbortRecv_Click exit");
		}

		void EndSend(IAsyncResult result) {

			System.Diagnostics.Debug.WriteLine(DateTime.Now.ToLongTimeString() + " EndSend enter");

			pcToUSB.EndTransfer(result);

			System.Diagnostics.Debug.WriteLine(DateTime.Now.ToLongTimeString() + " EndSend exit");

		}

		void EndRecv(IAsyncResult result) {

			System.Diagnostics.Debug.WriteLine(DateTime.Now.ToLongTimeString() + " EndRecv enter");

			byte[] data = (byte[])result.AsyncState;
			int recv = usbToPc.EndTransfer(result);

			AddToTextBox(data, recv);

			System.Diagnostics.Debug.WriteLine(DateTime.Now.ToLongTimeString() + " EndRecv exit");

		}

		delegate void __AT(byte[] data, int recv);

		void AddToTextBox(byte[] data, int recv) {
			if ( InvokeRequired ) {
				Invoke(new __AT(AddToTextBox), data, recv);
				return;
			}

			// do this
			textBox2.Text += "Recv: " + recv.ToString() + " bytes\r\n" + encoder.GetString(data) + "\n";
		}

	}
}